/* This file is part of:
 *
 * DeFortres - A utility for disabling Fortres
 *
 * Copyright 2001 David Barksdale
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <windows.h>
#include <stdio.h>
#include "resource.h"

LPCSTR gszAppName = "DeFortres v1.0";
HINSTANCE ghInst = NULL;
HWND ghWnd = NULL;

BOOL CALLBACK MainProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam );
WORD BackdoorPassword( DWORD dwKey );
BOOL Fortres3( HANDLE hFile, LPSTR szPassword, DWORD dwLen );
BOOL Fortres4( HANDLE hFile, LPSTR szPassword, DWORD dwLen );

INT WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, INT nCmdShow )
{
	MSG msg;

	ghInst = hInstance;
	if(( ghWnd = CreateDialog( hInstance, MAKEINTRESOURCE( IDD_MAIN ), NULL, (DLGPROC)MainProc )) == NULL )
	{
		MessageBox( NULL, "Unable to create main dialog", gszAppName, MB_SETFOREGROUND | MB_ICONERROR );
		return -1;
	}
	ShowWindow( ghWnd, nCmdShow );
	while( GetMessage( &msg, NULL, 0, 0 ))
	{
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}
	return msg.wParam;
}

BOOL CALLBACK MainProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch( uMsg )
	{
	case WM_INITDIALOG:
		{
			PostMessage( hWnd, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)(HICON)LoadIcon( ghInst, MAKEINTRESOURCE( IDI_MAIN )));
			SetWindowText( hWnd, gszAppName );
			return TRUE;
		}
	case WM_COMMAND:
		switch( LOWORD( wParam ))
		{
		case IDC_GENERATE:
			SetDlgItemInt( hWnd, IDC_EDIT_BACKDOOR_PASSWORD, BackdoorPassword( GetDlgItemInt( hWnd, IDC_EDIT_BACKDOOR_KEY, NULL, FALSE )), FALSE );
			return TRUE;
		case IDC_BROWSE:
			{
				OPENFILENAME OpenFileName;
				CHAR szFile[MAX_PATH];

				GetDlgItemText( hWnd, IDC_EDIT_FILE, szFile, MAX_PATH );
				memset( &OpenFileName, 0x00, sizeof( OPENFILENAME ));
				OpenFileName.lStructSize = sizeof( OPENFILENAME );
				OpenFileName.hwndOwner = hWnd;
				OpenFileName.lpstrFilter = "Fortres Settings (*.fg3;*.set)\0*.fg3;*.set\0All Files (*.*)\0*.*\0";
				OpenFileName.lpstrFile = szFile;
				OpenFileName.nMaxFile = MAX_PATH;
				OpenFileName.lpstrTitle = "Open Fortres Settings";
				OpenFileName.Flags = OFN_ALLOWMULTISELECT | OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_NONETWORKBUTTON;
				if( GetOpenFileName( &OpenFileName ))
					SetDlgItemText( hWnd, IDC_EDIT_FILE, szFile );
				return TRUE;
			}
		case IDC_DECRYPT:
			{
				HANDLE hFile;
				CHAR szFile[MAX_PATH], szPassword[64];

				GetDlgItemText( hWnd, IDC_EDIT_FILE, szFile, MAX_PATH );
				if(( hFile = CreateFile( szFile, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL )) == INVALID_HANDLE_VALUE )
				{
					SetDlgItemText( hWnd, IDC_EDIT_PASSWORD, "Unable to open settings file" );
					return TRUE;
				}
				if( strstr( strupr( szFile ), ".FG3" ) != NULL )
				{
					if( Fortres3( hFile, szPassword, 64 ))
						SetDlgItemText( hWnd, IDC_EDIT_PASSWORD, szPassword );
					else
						SetDlgItemText( hWnd, IDC_EDIT_PASSWORD, "Unable to decrypt Fortres v3 settings file" );
				}
				else if( strstr( strupr( szFile ), ".SET" ) != NULL )
				{
					if( Fortres4( hFile, szPassword, 64 ))
						SetDlgItemText( hWnd, IDC_EDIT_PASSWORD, szPassword );
					else
						SetDlgItemText( hWnd, IDC_EDIT_PASSWORD, "Unable to decrypt Fortres v4 settings file" );
				}
				else
				{
					if( Fortres3( hFile, szPassword, 64 ))
						SetDlgItemText( hWnd, IDC_EDIT_PASSWORD, szPassword );
					else if( Fortres4( hFile, szPassword, 64 ))
						SetDlgItemText( hWnd, IDC_EDIT_PASSWORD, szPassword );
					else
						SetDlgItemText( hWnd, IDC_EDIT_PASSWORD, "Unable to decrypt settings file" );
				}
				CloseHandle( hFile );
				return TRUE;
			}
		default:
			return FALSE;
		}
	case WM_SYSCOMMAND:
		switch( wParam )
		{
		case SC_CLOSE:
			PostQuitMessage( 0 );
			EndDialog( hWnd, TRUE );
			return TRUE;
		default:
			return FALSE;
		}
	default:
		return FALSE;
	}
}

// DWORD dwKey - the backdoor key
// The return value is the backdoor password
WORD BackdoorPassword( DWORD dwKey )
{
	SHORT x;

	x = ((SHORT)( dwKey * -1.2456 ) + 1 ) * 65533;
	x = ( x / 2 + 7 ) * 3;
	x /= 2;
	return x * x;
}

// Called by Fortres3
BYTE Fun( BYTE x, DWORD dwPos )
{
	DWORD i;

	dwPos %= 8;
	for( i = 0; i < dwPos; i++ )
		if( x & 0x80 )
			x = x * 2 + 1;
		else
			x *= 2;
	return x;
}

// HANDLE hFile - an open file handle to DEFAULT.FG3
// LPSTR szPassword - a pointer to a buffer to be filled with the password
// DWORD dwLen - the length of the buffer pointed to by szPassword
// The return value is TRUE if the password was successfully deciphered
BOOL Fortres3( HANDLE hFile, LPSTR szPassword, DWORD dwLen )
{
	DWORD dwRead, i, j;
	BYTE Buffer[648], Key[103];

	SetFilePointer( hFile, 234, NULL, FILE_BEGIN );
	ReadFile( hFile, Key, 103, &dwRead, NULL );
	if( dwRead != 103 )
		return FALSE;
	ReadFile( hFile, Buffer, 648, &dwRead, NULL );
	if( dwRead != 648 )
		return FALSE;
	for( i = 0, j = 0; i < 648; i++ )
		Buffer[i] = Fun((BYTE)( Fun( Buffer[i], i )	^ Key[j = ( j + 1 ) % 103] ), i ) ^ 0xB2;
	Buffer[16] = Buffer[97];
	Buffer[18] = Buffer[109];
	Buffer[20] = Buffer[73];
	Buffer[21] = Buffer[57];
	for( i = 0; i < dwLen && Buffer[i + 16]; i++ )
		szPassword[i] = Buffer[i + 16] + 0x1B;
	if( szPassword[i - 1] != 'C' )
		return FALSE;
	szPassword[i - 1] = '\0';
	return TRUE;
}

// HANDLE hFile - an open file handle to APPMGR.SET
// LPSTR szPassword - a pointer to a buffer to be filled with the password
// DWORD dwLen - the length of the buffer pointed to by szPassword
// The return value is TRUE if the password was successfully deciphered
BOOL Fortres4( HANDLE hFile, LPSTR szPassword, DWORD dwLen )
{
	DWORD i, j, dwRead;
	BYTE Buffer[455];

	ReadFile( hFile, Buffer, 455, &dwRead, NULL );
	if( dwRead != 455 )
		return FALSE;
	for( i = 0, j = 4; i < dwLen - 1; i++, j += 18 )
	{
		szPassword[i] = (CHAR)( Buffer[j] - Buffer[454 - i] + i * 3 );
		if( isalpha( szPassword[i] )
		&& !isupper( szPassword[i] )
		|| !isprint( szPassword[i] ))
			break;
	}
	szPassword[i] = '\0';
	return TRUE;
}
